/* $Id: table.h,v 1.2 2002/03/04 10:13:38 aa5779 Exp $ */
#ifndef TABLE_H
#define TABLE_H

#include "dstring.h"
#include "interp.h"

#ifndef TABLE_IMP
extern storage_class table_storage_class;
#endif

storage *table_create(interpreter *i, char *name, char *arg);

void table_destroy(interpreter *i, storage *s);

int table_check(interpreter *i, storage *s, dstring *key);
dstring *table_get(interpreter *i, storage *s, dstring *key);

void table_put(interpreter *i, storage *s, dstring *key, dstring *val);
void table_add(interpreter *i, storage *s, dstring *key, dstring *val);

void table_remove(interpreter *i, storage *s, dstring *key);

dstring *table_first(interpreter *i, storage *s, void **iter);
dstring *table_next(interpreter *i, storage *s, void **iter);
void table_enditer(interpreter *i, storage *s, void **iter);

int table_numofitems(interpreter *i, storage *s);

dstring *table_seek(interpreter *i, storage *s, void **iter, dstring *key);

#endif
